# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTIBILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.

bl_info = {
    "name" : "ToDo",
    "author" : "xz-blender repack", 
    "description" : "添加到做项目到您的blender文件，所以你永远不会忘记什么需要完成",
    "blender" : (4, 2, 0),
    "version" : (1, 1, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import textwrap
import os
from bpy.app.handlers import persistent
from datetime import datetime


addon_keymaps = {}
_icons = None
todo = {'sna_task': '', }


def sna_update_status_74D44(self, context):
    sna_updated_prop = self.status
    if sna_updated_prop == "Complete":
        self.percentage = 100
    elif sna_updated_prop == "ToDo":
        self.percentage = 0
    else:
        pass
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def ShowMessageBox(title,icon,message_lines,icons):
    scene = bpy.context.scene
    # Access the 2D cursor location
    cursor_location = scene.cursor.location 

    def draw(self, context):
        for i, line in enumerate(message_lines):
            icon_name = icons[i]
            self.layout.label(text=line, icon=icon_name)
    bpy.context.window_manager.popup_menu(draw, title=title, icon=icon)


def wrap_text(texters):
    threshold = (int(bpy.context.region.width / 10) if int(bpy.context.region.width <= 405) else int(bpy.context.region.width / 8))
    textTowrap = texters      
    wrapp = textwrap.TextWrapper(width=threshold)       
    wList = wrapp.wrap(text=textTowrap) 
    return wList


_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_kaban_B408A(layout_function, ):
    if (todo['sna_task'] != ''):
        box_508BE = layout_function.box()
        box_508BE.alert = False
        box_508BE.enabled = True
        box_508BE.active = True
        box_508BE.use_property_split = False
        box_508BE.use_property_decorate = False
        box_508BE.alignment = 'Expand'.upper()
        box_508BE.scale_x = 1.0
        box_508BE.scale_y = 1.0
        if not True: box_508BE.operator_context = "EXEC_DEFAULT"
        row_00645 = box_508BE.row(heading='', align=False)
        row_00645.alert = False
        row_00645.enabled = True
        row_00645.active = True
        row_00645.use_property_split = False
        row_00645.use_property_decorate = False
        row_00645.scale_x = 1.0
        row_00645.scale_y = 1.0
        row_00645.alignment = 'Expand'.upper()
        row_00645.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_00645.label(text='Info:  ' + bpy.context.scene.sna_todo[todo['sna_task']].name, icon_value=0)
        col_67BB3 = box_508BE.column(heading='', align=False)
        col_67BB3.alert = False
        col_67BB3.enabled = False
        col_67BB3.active = True
        col_67BB3.use_property_split = False
        col_67BB3.use_property_decorate = False
        col_67BB3.scale_x = 1.0
        col_67BB3.scale_y = 1.0
        col_67BB3.alignment = 'Expand'.upper()
        col_67BB3.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_09854 = col_67BB3.row(heading='', align=False)
        row_09854.alert = False
        row_09854.enabled = True
        row_09854.active = True
        row_09854.use_property_split = False
        row_09854.use_property_decorate = False
        row_09854.scale_x = 1.0
        row_09854.scale_y = 1.0
        row_09854.alignment = 'Left'.upper()
        row_09854.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_09854.label(text='Created: ' + bpy.context.scene.sna_todo[todo['sna_task']].created, icon_value=0)
        row_09854.label(text='Last Edited: ' + bpy.context.scene.sna_todo[todo['sna_task']].edited, icon_value=0)
        row_09583 = box_508BE.row(heading='', align=False)
        row_09583.alert = False
        row_09583.enabled = True
        row_09583.active = True
        row_09583.use_property_split = False
        row_09583.use_property_decorate = False
        row_09583.scale_x = 1.0
        row_09583.scale_y = 1.0
        row_09583.alignment = 'Left'.upper()
        row_09583.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_09583.prop(bpy.context.scene.sna_todo[todo['sna_task']], 'status', text='Status: ', icon_value=0, emboss=True)
        row_09583.prop(bpy.context.scene.sna_todo[todo['sna_task']], 'priority', text='Priority: ', icon_value=0, emboss=True)
        row_09583.prop(bpy.context.scene.sna_todo[todo['sna_task']], 'percentage', text='Percentage: ', icon_value=0, emboss=True)
        box_508BE.separator(factor=1.2000000476837158)
        for i_561CA in range(len(wrap_text(bpy.context.scene.sna_todo[todo['sna_task']].do))):
            box_508BE.label(text=str(wrap_text(bpy.context.scene.sna_todo[todo['sna_task']].do)[i_561CA]), icon_value=0)
        box_508BE.separator(factor=1.2000000476837158)
        row_D06D5 = box_508BE.row(heading='', align=True)
        row_D06D5.alert = False
        row_D06D5.enabled = True
        row_D06D5.active = True
        row_D06D5.use_property_split = False
        row_D06D5.use_property_decorate = False
        row_D06D5.scale_x = 1.0
        row_D06D5.scale_y = 1.0
        row_D06D5.alignment = 'Expand'.upper()
        row_D06D5.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_05FC1 = row_D06D5.row(heading='', align=True)
        row_05FC1.alert = True
        row_05FC1.enabled = True
        row_05FC1.active = True
        row_05FC1.use_property_split = False
        row_05FC1.use_property_decorate = False
        row_05FC1.scale_x = 1.0
        row_05FC1.scale_y = 1.0
        row_05FC1.alignment = 'Expand'.upper()
        row_05FC1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_05FC1.operator('sna.remove_d094d', text='', icon_value=32, emboss=True, depress=False)
        op.sna_int = bpy.context.scene.sna_todo.find(bpy.context.scene.sna_todo[todo['sna_task']].name)
        op = row_D06D5.operator('sna.edit_a0731', text='Edit', icon_value=701, emboss=True, depress=False)
        op.sna_int = bpy.context.scene.sna_todo.find(bpy.context.scene.sna_todo[todo['sna_task']].name)
        op.sna_edit = bpy.context.scene.sna_todo[todo['sna_task']].do
        op.sna_name = bpy.context.scene.sna_todo[todo['sna_task']].name
        op.sna_url = bpy.context.scene.sna_todo[todo['sna_task']].url
        if (bpy.context.scene.sna_todo[todo['sna_task']].url != ''):
            op = row_D06D5.operator('wm.url_open', text='', icon_value=72, emboss=True, depress=False)
            op.url = bpy.context.scene.sna_todo[todo['sna_task']].url
    layout_function.separator(factor=1.2000000476837158)
    row_DE932 = layout_function.row(heading='', align=True)
    row_DE932.alert = False
    row_DE932.enabled = True
    row_DE932.active = True
    row_DE932.use_property_split = False
    row_DE932.use_property_decorate = False
    row_DE932.scale_x = 1.0
    row_DE932.scale_y = 1.0
    row_DE932.alignment = 'Expand'.upper()
    row_DE932.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    col_217D1 = row_DE932.column(heading='', align=False)
    col_217D1.alert = False
    col_217D1.enabled = True
    col_217D1.active = True
    col_217D1.use_property_split = False
    col_217D1.use_property_decorate = False
    col_217D1.scale_x = 1.0
    col_217D1.scale_y = 1.0
    col_217D1.alignment = 'Expand'.upper()
    col_217D1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    box_D3DCA = col_217D1.box()
    box_D3DCA.alert = False
    box_D3DCA.enabled = True
    box_D3DCA.active = True
    box_D3DCA.use_property_split = False
    box_D3DCA.use_property_decorate = False
    box_D3DCA.alignment = 'Expand'.upper()
    box_D3DCA.scale_x = 1.0
    box_D3DCA.scale_y = 1.0
    if not True: box_D3DCA.operator_context = "EXEC_DEFAULT"
    box_D3DCA.label(text='ToDo', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'red.png')))
    for i_49A75 in range(len(bpy.context.scene.sna_todo)):
        if bpy.context.scene.sna_todo[i_49A75].status == "ToDo":
            row_21264 = box_D3DCA.row(heading='', align=True)
            row_21264.alert = False
            row_21264.enabled = True
            row_21264.active = True
            row_21264.use_property_split = False
            row_21264.use_property_decorate = False
            row_21264.scale_x = 1.0
            row_21264.scale_y = 1.0
            row_21264.alignment = 'Expand'.upper()
            row_21264.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_21264.operator('sna.display_kaban_65795', text=bpy.context.scene.sna_todo[i_49A75].name, icon_value=0, emboss=True, depress=bpy.context.scene.sna_todo[i_49A75].name in todo['sna_task'])
            op.sna_task = bpy.context.scene.sna_todo[i_49A75].name
            op = row_21264.operator('sna.change_status_forward_f76c4', text='', icon_value=718, emboss=True, depress=False)
            op.sna_task = bpy.context.scene.sna_todo[i_49A75].name
        else:
            pass
    col_495D1 = row_DE932.column(heading='', align=False)
    col_495D1.alert = False
    col_495D1.enabled = True
    col_495D1.active = True
    col_495D1.use_property_split = False
    col_495D1.use_property_decorate = False
    col_495D1.scale_x = 1.0
    col_495D1.scale_y = 1.0
    col_495D1.alignment = 'Expand'.upper()
    col_495D1.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    box_05ADD = col_495D1.box()
    box_05ADD.alert = False
    box_05ADD.enabled = True
    box_05ADD.active = True
    box_05ADD.use_property_split = False
    box_05ADD.use_property_decorate = False
    box_05ADD.alignment = 'Expand'.upper()
    box_05ADD.scale_x = 1.0
    box_05ADD.scale_y = 1.0
    if not True: box_05ADD.operator_context = "EXEC_DEFAULT"
    box_05ADD.label(text='InProgress', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'yellow.png')))
    for i_5650C in range(len(bpy.context.scene.sna_todo)):
        if bpy.context.scene.sna_todo[i_5650C].status == "InProgress":
            row_F2F40 = box_05ADD.row(heading='', align=True)
            row_F2F40.alert = False
            row_F2F40.enabled = True
            row_F2F40.active = True
            row_F2F40.use_property_split = False
            row_F2F40.use_property_decorate = False
            row_F2F40.scale_x = 1.0
            row_F2F40.scale_y = 1.0
            row_F2F40.alignment = 'Expand'.upper()
            row_F2F40.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_F2F40.operator('sna.change_status_back_cb8d0', text='', icon_value=717, emboss=True, depress=False)
            op.sna_task = bpy.context.scene.sna_todo[i_5650C].name
            op = row_F2F40.operator('sna.display_kaban_65795', text=bpy.context.scene.sna_todo[i_5650C].name, icon_value=0, emboss=True, depress=bpy.context.scene.sna_todo[i_5650C].name in todo['sna_task'])
            op.sna_task = bpy.context.scene.sna_todo[i_5650C].name
            op = row_F2F40.operator('sna.change_status_forward_f76c4', text='', icon_value=718, emboss=True, depress=False)
            op.sna_task = bpy.context.scene.sna_todo[i_5650C].name
        else:
            pass
    col_5865F = row_DE932.column(heading='', align=False)
    col_5865F.alert = False
    col_5865F.enabled = True
    col_5865F.active = True
    col_5865F.use_property_split = False
    col_5865F.use_property_decorate = False
    col_5865F.scale_x = 1.0
    col_5865F.scale_y = 1.0
    col_5865F.alignment = 'Expand'.upper()
    col_5865F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    box_228CB = col_5865F.box()
    box_228CB.alert = False
    box_228CB.enabled = True
    box_228CB.active = True
    box_228CB.use_property_split = False
    box_228CB.use_property_decorate = False
    box_228CB.alignment = 'Expand'.upper()
    box_228CB.scale_x = 1.0
    box_228CB.scale_y = 1.0
    if not True: box_228CB.operator_context = "EXEC_DEFAULT"
    box_228CB.label(text='Complete', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'green.png')))
    for i_266BE in range(len(bpy.context.scene.sna_todo)):
        if bpy.context.scene.sna_todo[i_266BE].status == "Complete":
            row_E74FD = box_228CB.row(heading='', align=True)
            row_E74FD.alert = False
            row_E74FD.enabled = True
            row_E74FD.active = True
            row_E74FD.use_property_split = False
            row_E74FD.use_property_decorate = False
            row_E74FD.scale_x = 1.0
            row_E74FD.scale_y = 1.0
            row_E74FD.alignment = 'Expand'.upper()
            row_E74FD.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
            op = row_E74FD.operator('sna.change_status_back_cb8d0', text='', icon_value=717, emboss=True, depress=False)
            op.sna_task = bpy.context.scene.sna_todo[i_266BE].name
            op = row_E74FD.operator('sna.display_kaban_65795', text=bpy.context.scene.sna_todo[i_266BE].name, icon_value=0, emboss=True, depress=bpy.context.scene.sna_todo[i_266BE].name in todo['sna_task'])
            op.sna_task = bpy.context.scene.sna_todo[i_266BE].name
        else:
            pass


class SNA_OT_Display_Kaban_65795(bpy.types.Operator):
    bl_idname = "sna.display_kaban_65795"
    bl_label = "Display Kaban"
    bl_description = "Display Kaban"
    bl_options = {"REGISTER", "UNDO"}
    sna_task: bpy.props.StringProperty(name='Task', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        todo['sna_task'] = self.sna_task
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Change_Status_Back_Cb8D0(bpy.types.Operator):
    bl_idname = "sna.change_status_back_cb8d0"
    bl_label = "Change Status Back"
    bl_description = "Change Status Back"
    bl_options = {"REGISTER", "UNDO"}
    sna_task: bpy.props.StringProperty(name='Task', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if bpy.context.scene.sna_todo[self.sna_task].status == "InProgress":
            bpy.context.scene.sna_todo[self.sna_task].status = 'ToDo'
        elif bpy.context.scene.sna_todo[self.sna_task].status == "Complete":
            bpy.context.scene.sna_todo[self.sna_task].status = 'InProgress'
        else:
            pass
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Change_Status_Forward_F76C4(bpy.types.Operator):
    bl_idname = "sna.change_status_forward_f76c4"
    bl_label = "Change Status Forward"
    bl_description = "Change Status Forward"
    bl_options = {"REGISTER", "UNDO"}
    sna_task: bpy.props.StringProperty(name='Task', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if bpy.context.scene.sna_todo[self.sna_task].status == "ToDo":
            bpy.context.scene.sna_todo[self.sna_task].status = 'InProgress'
        elif bpy.context.scene.sna_todo[self.sna_task].status == "InProgress":
            bpy.context.scene.sna_todo[self.sna_task].status = 'Complete'
        else:
            pass
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_TODO_A790B(bpy.types.Panel):
    bl_label = 'ToDo'
    bl_idname = 'SNA_PT_TODO_A790B'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'ToDo'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        box_2D31C = layout.box()
        box_2D31C.alert = False
        box_2D31C.enabled = True
        box_2D31C.active = True
        box_2D31C.use_property_split = False
        box_2D31C.use_property_decorate = False
        box_2D31C.alignment = 'Expand'.upper()
        box_2D31C.scale_x = 1.0
        box_2D31C.scale_y = 1.0
        if not True: box_2D31C.operator_context = "EXEC_DEFAULT"
        col_66EE3 = box_2D31C.column(heading='', align=False)
        col_66EE3.alert = False
        col_66EE3.enabled = True
        col_66EE3.active = True
        col_66EE3.use_property_split = False
        col_66EE3.use_property_decorate = False
        col_66EE3.scale_x = 1.0
        col_66EE3.scale_y = 1.0
        col_66EE3.alignment = 'Expand'.upper()
        col_66EE3.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        if bpy.context.scene.sna_view == "List":
            col_66EE3.prop(bpy.context.scene, 'sna_search_bar', text='Search', icon_value=30, emboss=True)
        else:
            pass
        row_DB311 = col_66EE3.row(heading='', align=False)
        row_DB311.alert = False
        row_DB311.enabled = True
        row_DB311.active = True
        row_DB311.use_property_split = False
        row_DB311.use_property_decorate = False
        row_DB311.scale_x = 1.0
        row_DB311.scale_y = 1.0
        row_DB311.alignment = 'Expand'.upper()
        row_DB311.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_C6035 = row_DB311.row(heading='', align=True)
        row_C6035.alert = False
        row_C6035.enabled = True
        row_C6035.active = True
        row_C6035.use_property_split = False
        row_C6035.use_property_decorate = False
        row_C6035.scale_x = 1.0
        row_C6035.scale_y = 1.0
        row_C6035.alignment = 'Expand'.upper()
        row_C6035.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = row_C6035.operator('sna.add_todo_962f3', text='Add', icon_value=9, emboss=True, depress=False)
        op.sna_do = ''
        op.sna_name = ''
        op.sna_url = ''
        if bpy.context.scene.sna_view == "List":
            op = row_C6035.operator('sna.shrink_all_0a7f9', text='', icon_value=4, emboss=True, depress=False)
            op = row_C6035.operator('sna.expand_all_b4606', text='', icon_value=5, emboss=True, depress=False)
        else:
            pass
        if bpy.context.scene.sna_view == "List":
            row_DB311.prop(bpy.context.scene, 'sna_priority', text='', icon_value=0, emboss=True)
        else:
            pass
        row_90C91 = col_66EE3.row(heading='', align=True)
        row_90C91.alert = False
        row_90C91.enabled = True
        row_90C91.active = True
        row_90C91.use_property_split = False
        row_90C91.use_property_decorate = False
        row_90C91.scale_x = 1.0
        row_90C91.scale_y = 1.0
        row_90C91.alignment = 'Expand'.upper()
        row_90C91.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_90C91.prop(bpy.context.scene, 'sna_view', text=bpy.context.scene.sna_view, icon_value=0, emboss=True, expand=True)
        layout.separator(factor=1.4500000476837158)
        if bpy.context.scene.sna_view == "List":
            layout_function = layout
            sna_list_view_BAD23(layout_function, )
        elif bpy.context.scene.sna_view == "Kanban":
            layout_function = layout
            sna_kaban_B408A(layout_function, )
        else:
            pass


class SNA_OT_Remove_D094D(bpy.types.Operator):
    bl_idname = "sna.remove_d094d"
    bl_label = "Remove"
    bl_description = "Remove your item"
    bl_options = {"REGISTER", "UNDO"}
    sna_int: bpy.props.IntProperty(name='int', description='', options={'HIDDEN'}, default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if len(bpy.context.scene.sna_todo) > self.sna_int:
            bpy.context.scene.sna_todo.remove(self.sna_int)
        todo['sna_task'] = ''
        sna_select_priority_E92DD()
        if bpy.context and bpy.context.screen:
            for a in bpy.context.screen.areas:
                a.tag_redraw()
        return {"FINISHED"}

    def invoke(self, context, event):
        return context.window_manager.invoke_confirm(self, event)


@persistent
def load_post_handler_35250(dummy):
    sna_select_priority_E92DD()


class SNA_OT_Info_37031(bpy.types.Operator):
    bl_idname = "sna.info_37031"
    bl_label = "Info"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_int: bpy.props.IntProperty(name='Int', description='', options={'HIDDEN'}, default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        ShowMessageBox('Details',
                                                          'QUESTION',
                                                          ['Priority: ' + bpy.context.scene.sna_todo[self.sna_int].priority, 'Created: ' + bpy.context.scene.sna_todo[self.sna_int].created, 'Edited: ' + bpy.context.scene.sna_todo[self.sna_int].edited],
                                                          ['PINNED', 'TIME', 'SORTTIME'])
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Move_Up_Fb7Da(bpy.types.Operator):
    bl_idname = "sna.move_up_fb7da"
    bl_label = "Move Up"
    bl_description = "Move Up"
    bl_options = {"REGISTER", "UNDO"}
    sna_inter: bpy.props.IntProperty(name='inter', description='', options={'HIDDEN'}, default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_todo.move(self.sna_inter, int(self.sna_inter - 1.0))
        item_7FB7F = bpy.context.scene.sna_todo[int(self.sna_inter - 1.0)]
        if bpy.context and bpy.context.screen:
            for a in bpy.context.screen.areas:
                a.tag_redraw()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Move_Down_3Ab4C(bpy.types.Operator):
    bl_idname = "sna.move_down_3ab4c"
    bl_label = "Move Down"
    bl_description = "Move down"
    bl_options = {"REGISTER", "UNDO"}
    sna_inter: bpy.props.IntProperty(name='inter', description='', options={'HIDDEN'}, default=0, subtype='NONE')

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_todo.move(self.sna_inter, int(self.sna_inter + 1.0))
        item_F2068 = bpy.context.scene.sna_todo[int(self.sna_inter + 1.0)]
        if bpy.context and bpy.context.screen:
            for a in bpy.context.screen.areas:
                a.tag_redraw()
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Edit_A0731(bpy.types.Operator):
    bl_idname = "sna.edit_a0731"
    bl_label = "Edit"
    bl_description = "Edit your item"
    bl_options = {"REGISTER", "UNDO"}
    bl_property = 'sna_edit'
    sna_int: bpy.props.IntProperty(name='int', description='', options={'HIDDEN'}, default=0, subtype='NONE')
    sna_edit: bpy.props.StringProperty(name='Edit', description='', options={'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    sna_name: bpy.props.StringProperty(name='Name', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    sna_url: bpy.props.StringProperty(name='Url', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_todo[self.sna_int].do = self.sna_edit
        bpy.context.scene.sna_todo[self.sna_int].edited = str(datetime.now().date().day) + '/' + str(datetime.now().date().month) + '/' + str(datetime.now().date().year) + ' ' + str(datetime.now().time().hour) + ':' + str(datetime.now().time().minute) + ':' + str(datetime.now().time().second)
        bpy.context.scene.sna_todo[self.sna_int].name = self.sna_name
        bpy.context.scene.sna_todo[self.sna_int].url = self.sna_url
        todo['sna_task'] = bpy.context.scene.sna_todo[self.sna_int].name
        if bpy.context and bpy.context.screen:
            for a in bpy.context.screen.areas:
                a.tag_redraw()
        return {"FINISHED"}

    def draw(self, context):
        layout = self.layout
        layout.prop(self, 'sna_name', text='Title', icon_value=0, emboss=True)
        layout.prop(self, 'sna_edit', text='Info', icon_value=0, emboss=True)
        layout.prop(self, 'sna_url', text='Url', icon_value=0, emboss=True)

    def invoke(self, context, event):
        self.sna_edit = bpy.context.scene.sna_todo[self.sna_int].do
        self.sna_name = bpy.context.scene.sna_todo[self.sna_int].name
        bpy.context.scene.sna_todo[self.sna_int].url = bpy.context.scene.sna_todo[self.sna_int].url
        return context.window_manager.invoke_props_dialog(self, width=300)


class SNA_OT_Add_Todo_962F3(bpy.types.Operator):
    bl_idname = "sna.add_todo_962f3"
    bl_label = "Add todo"
    bl_description = "Add aToDo item"
    bl_options = {"REGISTER", "UNDO"}
    bl_property = 'sna_name'
    sna_do: bpy.props.StringProperty(name='2do', description='', options={'HIDDEN'}, default='Add your text', subtype='NONE', maxlen=0)
    sna_name: bpy.props.StringProperty(name='Name', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    sna_url: bpy.props.StringProperty(name='Url', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        item_8EA3F = bpy.context.scene.sna_todo.add()
        item_8EA3F.do = self.sna_do
        item_8EA3F.created = str(datetime.now().date().day) + '/' + str(datetime.now().date().month) + '/' + str(datetime.now().date().year) + ' ' + str(datetime.now().time().hour) + ':' + str(datetime.now().time().minute) + ':' + str(datetime.now().time().second)
        item_8EA3F.edited = str(datetime.now().date().day) + '/' + str(datetime.now().date().month) + '/' + str(datetime.now().date().year) + ' ' + str(datetime.now().time().hour) + ':' + str(datetime.now().time().minute) + ':' + str(datetime.now().time().second)
        item_8EA3F.name = self.sna_name
        item_8EA3F.url = self.sna_url
        sna_select_priority_E92DD()
        if bpy.context and bpy.context.screen:
            for a in bpy.context.screen.areas:
                a.tag_redraw()
        return {"FINISHED"}

    def draw(self, context):
        layout = self.layout
        col_96B42 = layout.column(heading='', align=False)
        col_96B42.alert = False
        col_96B42.enabled = True
        col_96B42.active = True
        col_96B42.use_property_split = False
        col_96B42.use_property_decorate = False
        col_96B42.scale_x = 1.0
        col_96B42.scale_y = 1.0
        col_96B42.alignment = 'Expand'.upper()
        col_96B42.operator_context = "INVOKE_DEFAULT" if False else "EXEC_DEFAULT"
        col_96B42.prop(self, 'sna_name', text='Title', icon_value=0, emboss=True)
        col_96B42.prop(self, 'sna_do', text='Info', icon_value=0, emboss=True)
        col_96B42.prop(self, 'sna_url', text='Url', icon_value=0, emboss=True)

    def invoke(self, context, event):
        return context.window_manager.invoke_props_dialog(self, width=300)


class SNA_OT_Expand_All_B4606(bpy.types.Operator):
    bl_idname = "sna.expand_all_b4606"
    bl_label = "Expand All"
    bl_description = "Expand All"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        for i_963BA in range(len(bpy.context.scene.sna_todo)):
            bpy.context.scene.sna_todo[i_963BA].toggle = True
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Shrink_All_0A7F9(bpy.types.Operator):
    bl_idname = "sna.shrink_all_0a7f9"
    bl_label = "Shrink All"
    bl_description = "Shrink All"
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        for i_4EFA9 in range(len(bpy.context.scene.sna_todo)):
            bpy.context.scene.sna_todo[i_4EFA9].toggle = False
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_list_view_BAD23(layout_function, ):
    if (len(bpy.context.scene.sna_todo) == 0):
        layout_function.label(text='没有 ToDo 项目 :-) , 请添加一个', icon_value=227)
    else:
        if True:
            if (len(list(bpy.context.scene.sna_priority)) == 0):
                row_96EC4 = layout_function.row(heading='', align=False)
                row_96EC4.alert = False
                row_96EC4.enabled = True
                row_96EC4.active = True
                row_96EC4.use_property_split = False
                row_96EC4.use_property_decorate = False
                row_96EC4.scale_x = 1.0
                row_96EC4.scale_y = 1.0
                row_96EC4.alignment = 'Right'.upper()
                row_96EC4.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
                row_96EC4.label(text='Shift Click To Select Priorities', icon_value=0)
                row_96EC4.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'L.png')))
                row_96EC4.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'M.png')))
                row_96EC4.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'H.png')))
                row_96EC4.label(text='', icon_value=297)
            else:
                for i_895D3 in range(len(bpy.context.scene.sna_todo)):
                    if bpy.context.scene.sna_todo[i_895D3].priority in list(bpy.context.scene.sna_priority):
                        if ('' != bpy.context.scene.sna_search_bar):
                            if bpy.context.scene.sna_search_bar.lower() in bpy.context.scene.sna_todo[i_895D3].name.lower():
                                layout_function = layout_function
                                sna_listfilter_EF4FF(layout_function, bpy.context.scene.sna_todo[i_895D3], int(i_895D3 + 1.0), i_895D3)
                        else:
                            layout_function = layout_function
                            sna_listfilter_EF4FF(layout_function, bpy.context.scene.sna_todo[i_895D3], int(i_895D3 + 1.0), i_895D3)


def sna_listfilter_EF4FF(layout_function, input, int, truepos):
    box_06F51 = layout_function.box()
    box_06F51.alert = False
    box_06F51.enabled = True
    box_06F51.active = True
    box_06F51.use_property_split = False
    box_06F51.use_property_decorate = False
    box_06F51.alignment = 'Expand'.upper()
    box_06F51.scale_x = 1.0
    box_06F51.scale_y = 1.0
    if not True: box_06F51.operator_context = "EXEC_DEFAULT"
    if input.toggle:
        box_06F51.prop(input, 'toggle', text=input.name, icon_value=(5 if input.toggle else 4), emboss=False, expand=True, toggle=True)
        box_06F51.separator(factor=1.2999999523162842)
        for i_E7371 in range(len(wrap_text(input.do))):
            box_06F51.label(text=wrap_text(input.do)[i_E7371], icon_value=0)
        box_06F51.separator(factor=2.559999942779541)
        row_84EFB = box_06F51.row(heading='', align=True)
        row_84EFB.alert = False
        row_84EFB.enabled = True
        row_84EFB.active = True
        row_84EFB.use_property_split = False
        row_84EFB.use_property_decorate = False
        row_84EFB.scale_x = 1.0
        row_84EFB.scale_y = 1.0
        row_84EFB.alignment = 'Expand'.upper()
        row_84EFB.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_9FEF0 = row_84EFB.column(heading='', align=False)
        col_9FEF0.alert = True
        col_9FEF0.enabled = True
        col_9FEF0.active = True
        col_9FEF0.use_property_split = False
        col_9FEF0.use_property_decorate = False
        col_9FEF0.scale_x = 1.0
        col_9FEF0.scale_y = 1.0
        col_9FEF0.alignment = 'Expand'.upper()
        col_9FEF0.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        op = col_9FEF0.operator('sna.remove_d094d', text='', icon_value=32, emboss=True, depress=False)
        op.sna_int = truepos
        op = row_84EFB.operator('sna.edit_a0731', text='', icon_value=701, emboss=True, depress=False)
        op.sna_int = truepos
        op.sna_edit = input.do
        op.sna_name = input.name
        op.sna_url = input.url
        if (int == 1):
            if (len(bpy.context.scene.sna_todo) == 1):
                pass
            else:
                op = row_84EFB.operator('sna.move_down_3ab4c', text='', icon_value=5, emboss=True, depress=False)
                op.sna_inter = truepos
        else:
            if (int == len(bpy.context.scene.sna_todo)):
                op = row_84EFB.operator('sna.move_up_fb7da', text='', icon_value=7, emboss=True, depress=False)
                op.sna_inter = truepos
            else:
                if (int > 0):
                    op = row_84EFB.operator('sna.move_up_fb7da', text='', icon_value=7, emboss=True, depress=False)
                    op.sna_inter = truepos
                    op = row_84EFB.operator('sna.move_down_3ab4c', text='', icon_value=5, emboss=True, depress=False)
                    op.sna_inter = truepos
        row_84EFB.prop(input, 'priority', text='', icon_value=0, emboss=True, expand=False, toggle=True)
        row_84EFB.prop(input, 'status', text='', icon_value=0, emboss=True, expand=False, toggle=True)
        row_84EFB.prop(input, 'percentage', text='Progress', icon_value=0, emboss=True, expand=True, slider=True)
        if (input.url != ''):
            op = row_84EFB.operator('wm.url_open', text='', icon_value=72, emboss=True, depress=False)
            op.url = input.url
        op = row_84EFB.operator('sna.info_37031', text='', icon_value=1, emboss=True, depress=False)
        op.sna_int = truepos
    else:
        row_0137F = box_06F51.row(heading='', align=True)
        row_0137F.alert = False
        row_0137F.enabled = True
        row_0137F.active = True
        row_0137F.use_property_split = False
        row_0137F.use_property_decorate = False
        row_0137F.scale_x = 1.0
        row_0137F.scale_y = 1.0
        row_0137F.alignment = 'Expand'.upper()
        row_0137F.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_0137F.prop(input, 'toggle', text=input.name, icon_value=(5 if input.toggle else 4), emboss=False, expand=True, toggle=False)
        row_A4D5A = row_0137F.row(heading='', align=False)
        row_A4D5A.alert = False
        row_A4D5A.enabled = True
        row_A4D5A.active = True
        row_A4D5A.use_property_split = False
        row_A4D5A.use_property_decorate = False
        row_A4D5A.scale_x = 1.0
        row_A4D5A.scale_y = 1.0
        row_A4D5A.alignment = 'Right'.upper()
        row_A4D5A.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        row_A4D5A.label(text=str(input.percentage) + '%', icon_value=0)
        if input.status == "ToDo":
            if input.priority == "Low":
                row_A4D5A.label(text='Low', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'red.png')))
            elif input.priority == "Medium":
                row_A4D5A.label(text='Medium', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'red.png')))
            elif input.priority == "High":
                row_A4D5A.label(text='High', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'red.png')))
            else:
                pass
        elif input.status == "InProgress":
            if input.priority == "Low":
                row_A4D5A.label(text='Low', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'yellow.png')))
            elif input.priority == "Medium":
                row_A4D5A.label(text='Medium', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'yellow.png')))
            elif input.priority == "High":
                row_A4D5A.label(text='High', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'yellow.png')))
            else:
                pass
        elif input.status == "Complete":
            if input.priority == "Low":
                row_A4D5A.label(text='Low', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'green.png')))
            elif input.priority == "Medium":
                row_A4D5A.label(text='Medium', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'green.png')))
            elif input.priority == "High":
                row_A4D5A.label(text='High', icon_value=0)
                row_A4D5A.label(text='', icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'green.png')))
            else:
                pass
        else:
            pass


def sna_select_priority_E92DD():
    bpy.context.scene.sna_priority = set(['Low', 'Medium', 'High'])
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def sna_todogroup_status_enum_items(self, context):
    enum_items = [['ToDo', 'ToDo', 'ToDo', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'red.png'))], ['InProgress', 'InProgress', 'InProgress', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'yellow.png'))], ['Complete', 'Complete', 'Complete', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'green.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_todogroup_priority_enum_items(self, context):
    enum_items = [['Low', 'Low', 'Low', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'L.png'))], ['Medium', 'Medium', 'Medium', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'M.png'))], ['High', 'High', 'High', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'H.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_priority_enum_items(self, context):
    enum_items = [['Low', 'Low', 'Low', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'L.png'))], ['Medium', 'Medium', 'Medium', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'M.png'))], ['High', 'High', 'High', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'H.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], 2**i) for i, item in enumerate(enum_items)]


class SNA_GROUP_sna_todogroup(bpy.types.PropertyGroup):
    name: bpy.props.StringProperty(name='Name', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    do: bpy.props.StringProperty(name='2DO', description='', options={'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    priority: bpy.props.EnumProperty(name='Priority', description='', options={'HIDDEN'}, items=sna_todogroup_priority_enum_items)
    created: bpy.props.StringProperty(name='Created', description='', options={'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    edited: bpy.props.StringProperty(name='Edited', description='', options={'HIDDEN'}, default='', subtype='NONE', maxlen=0)
    percentage: bpy.props.IntProperty(name='Percentage', description='', options={'SKIP_SAVE', 'HIDDEN'}, default=0, subtype='PERCENTAGE', min=0, max=100)
    status: bpy.props.EnumProperty(name='Status', description='', options={'HIDDEN'}, items=sna_todogroup_status_enum_items, update=sna_update_status_74D44)
    toggle: bpy.props.BoolProperty(name='Toggle', description='', options={'HIDDEN'}, default=False)
    url: bpy.props.StringProperty(name='url', description='', options={'SKIP_SAVE', 'HIDDEN'}, default='', subtype='NONE', maxlen=0)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_GROUP_sna_todogroup)
    bpy.types.Scene.sna_todo = bpy.props.CollectionProperty(name='ToDo', description='', type=SNA_GROUP_sna_todogroup)
    bpy.types.Scene.sna_ind = bpy.props.IntProperty(name='ind', description='', default=0, subtype='NONE')
    bpy.types.Scene.sna_priority = bpy.props.EnumProperty(name='Priority', description='', items=sna_priority_enum_items, options={'ENUM_FLAG'})
    bpy.types.Scene.sna_view = bpy.props.EnumProperty(name='View', description='', items=[('List', 'List', 'List', 18, 0), ('Kanban', 'Kanban', 'Kanban', 754, 1)])
    bpy.types.Scene.sna_search_bar = bpy.props.StringProperty(name='Search Bar', description='', default='', subtype='NONE', maxlen=0)
    bpy.utils.register_class(SNA_OT_Display_Kaban_65795)
    bpy.utils.register_class(SNA_OT_Change_Status_Back_Cb8D0)
    bpy.utils.register_class(SNA_OT_Change_Status_Forward_F76C4)
    bpy.utils.register_class(SNA_PT_TODO_A790B)
    bpy.utils.register_class(SNA_OT_Remove_D094D)
    bpy.app.handlers.load_post.append(load_post_handler_35250)
    bpy.utils.register_class(SNA_OT_Info_37031)
    bpy.utils.register_class(SNA_OT_Move_Up_Fb7Da)
    bpy.utils.register_class(SNA_OT_Move_Down_3Ab4C)
    bpy.utils.register_class(SNA_OT_Edit_A0731)
    bpy.utils.register_class(SNA_OT_Add_Todo_962F3)
    bpy.utils.register_class(SNA_OT_Expand_All_B4606)
    bpy.utils.register_class(SNA_OT_Shrink_All_0A7F9)
    from pathlib import Path
    print(f"{Path(__file__).parent.name} 插件由xz-blender购买分享!感谢支持!")


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_search_bar
    del bpy.types.Scene.sna_view
    del bpy.types.Scene.sna_priority
    del bpy.types.Scene.sna_ind
    del bpy.types.Scene.sna_todo
    bpy.utils.unregister_class(SNA_GROUP_sna_todogroup)
    bpy.utils.unregister_class(SNA_OT_Display_Kaban_65795)
    bpy.utils.unregister_class(SNA_OT_Change_Status_Back_Cb8D0)
    bpy.utils.unregister_class(SNA_OT_Change_Status_Forward_F76C4)
    bpy.utils.unregister_class(SNA_PT_TODO_A790B)
    bpy.utils.unregister_class(SNA_OT_Remove_D094D)
    bpy.app.handlers.load_post.remove(load_post_handler_35250)
    bpy.utils.unregister_class(SNA_OT_Info_37031)
    bpy.utils.unregister_class(SNA_OT_Move_Up_Fb7Da)
    bpy.utils.unregister_class(SNA_OT_Move_Down_3Ab4C)
    bpy.utils.unregister_class(SNA_OT_Edit_A0731)
    bpy.utils.unregister_class(SNA_OT_Add_Todo_962F3)
    bpy.utils.unregister_class(SNA_OT_Expand_All_B4606)
    bpy.utils.unregister_class(SNA_OT_Shrink_All_0A7F9)
